SystemOrganization addCategory: #'Codex-Parser'!
SystemOrganization addCategory: #'Codex-Tests'!

PPCompositeParser subclass: #CXGrammar
	instanceVariableNames: 'eol directive keyword value label list section listBody sectionBody whitespace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Parser'!

!CXGrammar class methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 22:19'!
ignoredNames
	^ super ignoredNames, #(name)! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/19/2009 21:40'!
directive
	^ keyword, label, value optional! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 00:56'!
eol
	^ #newline asParser plus! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 21:58'!
keyword
	^ #lowercase asParser plus token! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 00:56'!
label
	^ (#word asParser / (PPPredicateParser anyOf: '.-_/:')) plus token! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:46'!
list
	^ $( asParser, listBody, $) asParser! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:49'!
listBody
	^ eol optional, (label, eol optional) star! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/21/2009 10:07'!
section
	^ ${ asParser token , sectionBody , $} asParser token! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/22/2009 22:27'!
sectionBody
	^ eol optional, (directive separatedBy: eol token plus) optional, eol optional! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/21/2009 10:16'!
start
	^ (sectionBody, whitespace optional) end! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 00:55'!
tokenParser
	^ CXTokenParser! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/22/2009 22:06'!
value
	^ list / section / label! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:45'!
whitespace
	^ #space asParser plus! !

CXGrammar subclass: #CXParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Parser'!

!CXParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/22/2009 10:45'!
directive
	^ super directive ==>
		[:nodes | 
		CXDirective
			identifier: nodes first value
			name: nodes second value
			value: nodes third value]! !

!CXParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/22/2009 12:51'!
list
	^ super list ==> [:nodes | CXList withAll: nodes second]! !

!CXParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/22/2009 12:51'!
listBody
	^ super listBody ==>
		[:nodes | 
		Array streamContents:
			[:out |
			(nodes at: 2) do:
				[:pair |
				out nextPut: pair first value]]]! !

!CXParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/22/2009 22:04'!
section
	^ super section ==> [:nodes | nodes second]! !

!CXParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/22/2009 22:54'!
sectionBody
	| directives |
	^ super sectionBody ==>
		[:nodes |
		directives := nodes at: 2.
		CXSection directives: 
			(directives 
				ifNil: [#()]
				ifNotNil: [directives select: [:ea | ea class = CXDirective]])]! !

!CXParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/22/2009 23:02'!
start
	^ super start ==> [:nodes | nodes first]! !

TestCase subclass: #CXParserResultTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Tests'!

!CXParserResultTest methodsFor: 'support' stamp: 'cwp 12/22/2009 10:29'!
mc2Codex
	^ 'import Grease
import OmniBrowser

repository wiresong-mc http://source.wiresong.ca/mc

package MC2-Squeak-Platform
package MC2-Core
package MC2-Smalltalk
package MC2-Export-Chunk
package MC2-Repository-File
package MC2-Repository-Directory
package MC2-Repository-Network
package MC2-Meta-Core
package MC2-Meta-Repository-File
package MC2-Meta-Repository-Directory
package MC2-Meta-Repository-Network
package MC2-OmniBrowser
package MC2-Tests-Core
package MC2-Tests-Export-Chunk
package MC2-Tests-Repository-File
package MC2-Tests-Repository-Directory
package MC2-Tests-Repository-Network
package MC2-Tests-OmniBrowser
package MC2-Tests-Meta-Core
package MC2-Tests-Meta-Repository-File
package MC2-Tests-Meta-Repository-Directory
package MC2-Tests-Meta-Repository-Network

group DEFAULT (
	MC2-Squeak-Platform
	MC2-Core
	MC2-Smalltalk
	MC2-Squeak-Smalltalk
	MC2-Export-Chunk
	MC2-Repository-File
	MC2-Repository-Directory
	MC2-Repository-Network
	MC2-OmniBrowser
	MC2-Meta-Core
	MC2-Meta-Squeak-Smalltalk
	MC2-Meta-Repository-File
	MC2-Meta-Repository-Directory
	MC2-Meta-Repository-Network
)

group Tests (
	MC2-Tests-Core
	MC2-Tests-Export-Chunk
	MC2-Tests-Smalltalk
	MC2-Tests-Squeak-Smalltalk
	MC2-Tests-Repository-File
	MC2-Tests-Repository-Directory
	MC2-Tests-Repository-Network
	MC2-Tests-Meta-Core
	MC2-Tests-OmniBrowser
	MC2-Tests-Meta-Squeak-Smalltalk
	MC2-Tests-Meta-Repository-File
	MC2-Tests-Meta-Repository-Directory
	MC2-Tests-Meta-Repository-Network
)

dependencies MC2-Core (
	Grease-Core
	Grease-Pharo-Core
	MC2-Platform
)

dependencies MC2-Smalltalk (MC2-Core)
dependencies MC2-Squeak-Smalltalk (MC2-Smalltalk)

dependencies MC2-Export-Chunk (
	MC2-Core 
	MC2-Smalltalk
)

dependencies MC2-Repository-File (MC2-Core)
dependencies MC2-Repository-Directory (MC2-Repository-File)
dependencies MC2-Repository-Network (MC2-Core)
dependencies MC2-Meta-Core (MC2-Core)

dependencies MC2-Meta-Squeak-Smalltalk (
	MC2-Meta-Core 
	MC2-Squeak-Smalltalk
)

dependencies MC2-Meta-Repository-File (
	MC2-Meta-Core 
	MC2-Repository-File
)

dependencies MC2-Meta-Repository-Directory (
	MC2-Meta-Core 
	MC2-Repository-Directory
)

dependencies MC2-Meta-Repository-Network (
	MC2-Meta-Core 
	MC2-Repository-Network
)

dependencies MC2-OmniBrowser (
	MC2-Core 
	OmniBrowser 
	OB-Morphic
)

dependencies MC2-Tests-Core (MC2-Core)
dependencies MC2-Tests-Export-Chunk (MC2-Export-Chunk)

dependencies MC2-Tests-Smalltalk (
	MC2-Tests-Core
	MC2-Smalltalk 
	MC2-Meta-Core
)

dependencies MC2-Tests-Squeak-Smalltalk (
	MC2-Tests-Core 
	MC2-Tests-Smalltalk 
	MC2-Squeak-Smalltalk
)

dependencies MC2-Tests-Repository-File (
	MC2-Tests-Core 
	MC2-Repository-File
)

dependencies MC2-Tests-Repository-Directory (
	MC2-Tests-Core 
	MC2-Repository-Directory
)

dependencies MC2-Tests-Repository-Network (
	MC2-Tests-Core 
	MC2-Repository-Network 
	MockLibrary
)

dependencies MC2-Tests-OmniBrowser (
	MC2-OmniBrowser MC2-Squeak-Smalltalk 
	MC2-Repository-Directory 
	MC2-Repository-File
	MC2-Repository-Network
	MC2-Tests-Meta-Core
	OB-Tests-Core 
)

dependencies MC2-Tests-Meta-Core (
	MC2-Tests-Core 
	MC2-Meta-Core
)

dependencies MC2-Tests-Meta-Squeak-Smalltalk (
	MC2-Tests-Meta-Core 
	MC2-Meta-Squeak-Smalltalk
)

dependencies MC2-Tests-Meta-Repository-File (
	MC2-Tests-Meta-Core 
	MC2-Meta-Repository-File
)

dependencies MC2-Tests-Meta-Repository-Directory (
	MC2-Tests-Meta-Core 
	MC2-Meta-Repository-Directory
)

dependencies MC2-Tests-Meta-Repository-Network (
	MC2-Tests-Meta-Core 
	MC2-Meta-Repository-Network
)

section squeak-common {
	platform squeak
	platform pharo
	
	alias MC2-Platform MC2-SqueakPlatform
	package MC2-Squeak-Smalltalk
	package MC2-Meta-Squeak-Smalltalk
	package MC2-Tests-Squeak-Smalltalk
	package MC2-Tests-Meta-Squeak-Smalltalk	
}

section baseline-1 {
	version MC2-SqueakPlatform MC2-SqueakPlatform-cwp.37
	version MC2-Core MC2-Core-cwp.14
	version MC2-Smalltalk MC2-Smalltalk-jf.1
	version MC2-Squeak-Smalltalk MC2-Squeak-Smalltalk-cwp.12
	version MC2-Export-Chunk MC2-Export-Chunk-jf.2
	version MC2-Repository-File MC2-Repository-File-cwp.4
	version MC2-Repository-Directory MC2-Repository-Directory-jf.2
	version MC2-Repository-Network MC2-Repository-Network-cwp.3
	version MC2-Meta-Core MC2-Meta-Core-jf.4
	version MC2-Meta-Squeak-Smalltalk MC2-Meta-Squeak-Smalltalk-cwp.1
	version MC2-Meta-Repository-File MC2-Meta-Repository-File-cwp.1
	version MC2-Meta-Repository-Directory MC2-Meta-Repository-Directory-cwp.1
	version MC2-Meta-Repository-Network MC2-Meta-Repository-Network-cwp.1
	version MC2-OmniBrowser MC2-OmniBrowser-jf.4
	version MC2-Tests-Core MC2-Tests-Core-cwp.16
	version MC2-Tests-Export-Chunk MC2-Tests-Export-Chunk-cwp.2
	version MC2-Tests-Smalltalk MC2-Tests-Smalltalk-cwp.4
	version MC2-Tests-Squeak-Smalltalk MC2-Tests-Squeak-Smalltalk-cwp.10
	version MC2-Tests-Repository-File MC2-Tests-Repository-File-cwp.1
	version MC2-Tests-Repository-Directory MC2-Tests-Repository-Directory-jf.2
	version MC2-Tests-Repository-Network MC2-Tests-Repository-Network-jf.2
	version MC2-Tests-OmniBrowser MC2-Tests-OmniBrowser-cwp.1
	version MC2-Tests-Meta-Core MC2-Tests-Meta-Core-cwp.5
	version MC2-Tests-Meta-Squeak-Smalltalk MC2-Tests-Meta-Squeak-Smalltalk-cwp.2
	version MC2-Tests-Meta-Repository-File MC2-Tests-Meta-Repository-File-jf.1
	version MC2-Tests-Meta-Repository-Directory MC2-Tests-Meta-Repository-Directory-jf.1
	version MC2-Tests-Meta-Repository-Network MC2-Tests-Meta-Repository-Network-jf.1
	version MockLibrary MockLibrary-cwp.7
}

section baseline-2 {
	include baseline-1
	version MC2-Core MC2-Core-cwp.15
}

release 2.1.0 {
	blessing alpha
	include baseline-1
	include squeak-common
}

release 2.1.1 {
	blessing beta
	include baseline-2
	include squeak-common
}
'! !

!CXParserResultTest methodsFor: 'tests' stamp: 'cwp 12/22/2009 10:23'!
testAlias
	| directive |
	directive := self parseDirective: 'alias Nurp Griffle'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'alias'.
	self assert: directive name = 'Nurp'.
	self assert: directive value = 'Griffle'.! !

!CXParserResultTest methodsFor: 'tests' stamp: 'cwp 12/22/2009 10:23'!
testGroupOne
	| directive |
	directive := self parseDirective: 'group Nurp (Griffle)'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'group'.
	self assert: directive name = 'Nurp'.
	self assert: directive value names = #('Griffle').! !

!CXParserResultTest methodsFor: 'tests' stamp: 'cwp 12/22/2009 10:23'!
testGroupTwo
	| directive |
	directive := self parseDirective: 'group Nurp (Griffle Plonk)'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'group'.
	self assert: directive name = 'Nurp'.
	self assert: directive value names = #('Griffle' 'Plonk').! !

!CXParserResultTest methodsFor: 'tests' stamp: 'cwp 12/22/2009 10:23'!
testGroupZero
	| directive |
	directive := self parseDirective: 'group Nurp ()'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'group'.
	self assert: directive name = 'Nurp'.
	self assert: directive value names = #().! !

!CXParserResultTest methodsFor: 'tests' stamp: 'cwp 12/22/2009 10:24'!
testPackageName
	| directive |
	directive := self parseDirective: 'package Nurp'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'package'.
	self assert: directive name = 'Nurp'.! !

!CXParserResultTest methodsFor: 'tests' stamp: 'cwp 12/22/2009 22:29'!
testSectionEmpty
	| directive |
	directive := self parseDirective: 'group Nurp {}'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'group'.
	self assert: directive name = 'Nurp'.
	self assert: (directive value isKindOf: CXSection).
	self assert: directive value directives isEmpty! !

!CXParserResultTest methodsFor: 'tests' stamp: 'cwp 12/22/2009 10:24'!
testSectionOne
	| directive |
	directive := self parseDirective: 'group Nurp {package Plonk}'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'group'.
	self assert: directive name = 'Nurp'.
	self assert: (directive value isKindOf: CXSection).
	self assert: directive value directives size = 1.
	self assert: directive value directives first name = 'Plonk'! !

!CXParserResultTest methodsFor: 'tests' stamp: 'cwp 12/22/2009 10:24'!
testSectionTwo
	| directive text |
	text := 'group Nurp {
		package Plonk 
		package Griffle
	}'.
	directive := self parseDirective: text.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'group'.
	self assert: directive name = 'Nurp'.
	self assert: (directive value isKindOf: CXSection).
	self assert: directive value directives size = 2.
	self assert: directive value directives first name = 'Plonk'.
	self assert: directive value directives second name = 'Griffle'! !

!CXParserResultTest methodsFor: 'tests' stamp: 'cwp 12/22/2009 10:24'!
testSectionTwoLowercase
	| directive |
	directive := self parseDirective: 'group nurp {
	package Plonk 
	package Griffle
}'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'group'.
	self assert: directive name = 'nurp'.
	self assert: (directive value isKindOf: CXSection).
	self assert: directive value directives size = 2.
	self assert: directive value directives first name = 'Plonk'.
	self assert: directive value directives second name = 'Griffle'! !

CXParserResultTest subclass: #CXParserTest
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Tests'!

!CXParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/22/2009 10:46'!
parseDirective: aString 
	| production |
	production := CXParser new instVarNamed: #directive.
	result := production parse: aString asParserStream.
	self 
		deny: result isFailure
		description: 'Unable to parse ' , aString printString.
	^ result! !

!CXParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/22/2009 10:30'!
parseSection: aString
	| production |
	production := CXParser new.
	result := production end parse: aString asParserStream.
	self 
		deny: result isFailure
		description: 'Unable to parse ' , aString printString.
	^ result! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/22/2009 23:01'!
testExample
	self parseSection: self mc2Codex.
	! !

CXParserResultTest subclass: #CXSmaccParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Tests'!

!CXSmaccParserTest methodsFor: 'support' stamp: 'cwp 12/22/2009 10:25'!
parseDirective: aString 
	| section |
	section := self parseSection: aString.
	^ section directives first! !

!CXSmaccParserTest methodsFor: 'support' stamp: 'cwp 12/22/2009 10:25'!
parseSection: aString 
	^ CXSmaccParser parse: aString! !

!CXSmaccParserTest methodsFor: 'tests' stamp: 'cwp 12/22/2009 23:00'!
testExample
	self 
		shouldnt: [ self parseSection: self mc2Codex ]
		raise: SmaCCParserError! !

TestCase subclass: #CXPetitParserTest
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Tests'!

CXPetitParserTest subclass: #CXGrammarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Tests'!

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 20:53'!
parserClass
	^ CXGrammar! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:30'!
testCapital
	self parse: 'Alias' rule: #label.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:31'!
testDash
	self parse: 'nurp-griffle' rule: #label.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:19'!
testDirective
	self parse: 'package Nurp' rule: #directive.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/21/2009 23:40'!
testDirectiveWithBlankLine
	self 
		parse: 'keyword la-bel {
	keyword2 Label2
	
	keyword3 Label3
}' 
		rule: #directive.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:42'!
testDirectiveWithLabel
	self parse: 'keyword Label1 Label2' rule: #directive.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:43'!
testDirectiveWithList
	self parse: 'keyword Label1 (Label2 Label3)' rule: #directive.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:43'!
testDirectiveWithList2
	self parse: 'keyword Label1 (
		Label2 
		Label3
)' rule: #directive.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/21/2009 23:02'!
testDirectiveWithMultisection
	self 
		parse: 'keyword la-bel {
	keyword2 Label2
	keyword3 Label3
}' 
		rule: #directive.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/21/2009 22:53'!
testDirectiveWithSection
	self parse: 'keyword Label1 {keyword2 Label2}' rule: #directive.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:29'!
testKeyword
	self parse: 'alias' rule: #keyword.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:51'!
testListInline
	self parse: '(Label1 Label2)' rule: #list.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:51'!
testListMultiline
	self parse: '(
	Label1
	Label2
)' rule: #list.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/22/2009 22:24'!
testSection0
	self parse: '{}' rule: #section.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/21/2009 10:03'!
testSection1
	self parse: '{package Nurp}' rule: #section.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/21/2009 10:04'!
testSection1Multiline
	self parse: '{
	package Nurp
}' rule: #section.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/21/2009 10:04'!
testSection2Multiline
	self parse: '{
	package Nurp
	package Griffle
}' rule: #section.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/21/2009 10:08'!
testSectionDirective
	self parse: 'package Gooly {package Nurp}' rule: #directive.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/22/2009 22:27'!
testSectionEmpty
	self parse: '' rule: #sectionBody.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:32'!
testUnderscore
	self parse: 'nurp_griffle' rule: #label.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:33'!
testUrl
	self parse: 'http://www.squeak.org/download.html' rule: #label.
	! !

!CXPetitParserTest class methodsFor: 'testing' stamp: 'cwp 12/20/2009 20:43'!
isAbstract
	^ self name = #PPGrammarTest! !

!CXPetitParserTest class methodsFor: 'accessing' stamp: 'cwp 12/20/2009 20:43'!
packageNamesUnderTest
	^ #('PetitSmalltalk')! !

!CXPetitParserTest class methodsFor: 'accessing' stamp: 'cwp 12/20/2009 20:43'!
resources
	^ Array with: PPGrammarResource! !

!CXPetitParserTest methodsFor: 'parsing' stamp: 'cwp 12/20/2009 20:43'!
parse: aString rule: aSymbol 
	| production |
	production := self parser.
	aSymbol = #start 
		ifFalse: [ production := production instVarNamed: aSymbol ].
	result := production end
		parse: aString asParserStream.
	self 
		deny: result isFailure
		description: 'Unable to parse ' , aString printString! !

!CXPetitParserTest methodsFor: 'accessing' stamp: 'cwp 12/20/2009 20:43'!
parser
	^ PPGrammarResource current parserAt: self parserClass! !

!CXPetitParserTest methodsFor: 'accessing' stamp: 'cwp 12/20/2009 20:43'!
parserClass
	self subclassResponsibility! !

PPTokenParser subclass: #CXTokenParser
	instanceVariableNames: 'spaces'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Parser'!

!CXTokenParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 00:37'!
consumeSpaces: aStream
	[ aStream atEnd not and: [ spaces includes: aStream peek  ] ]
		whileTrue: [ aStream next ]! !

!CXTokenParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:18'!
initialize
	spaces := String new: 2.
	spaces at: 1 put: Character space.
	spaces at: 2 put: Character tab.! !

Object subclass: #CXDirective
	instanceVariableNames: 'identifier name value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Parser'!

!CXDirective class methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2009 21:19'!
identifier: iString name: nString
	^ self identifier: iString name: nString value: nil! !

!CXDirective class methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2009 21:19'!
identifier: iString name: nString value: anObject
	^ self basicNew 
		initializeWithIdentifier: iString 
		name: nString
		value: anObject! !

!CXDirective methodsFor: 'accessing' stamp: 'cwp 12/16/2009 21:21'!
identifier
	^ identifier! !

!CXDirective methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2009 21:18'!
initializeWithIdentifier: iString name: nString value: anObject
	identifier := iString.
	name := nString.
	value := anObject.! !

!CXDirective methodsFor: 'accessing' stamp: 'cwp 12/16/2009 21:21'!
name
	^ name! !

!CXDirective methodsFor: 'accessing' stamp: 'cwp 12/16/2009 21:21'!
value
	^ value! !

Object subclass: #CXList
	instanceVariableNames: 'names'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Parser'!

!CXList class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2009 21:13'!
new
	^ self withAll: Array new! !

!CXList class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2009 21:07'!
with: aString
	^ self withAll: (Array with: aString)! !

!CXList class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2009 21:08'!
withAll: anArray
	^ self basicNew initializeWithNames: anArray! !

!CXList methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2009 21:06'!
addName: aString
	names := names copyWith: aString! !

!CXList methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2009 21:08'!
initializeWithNames: anArray
	self initialize.
	names := anArray! !

!CXList methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2009 21:12'!
names
	^ names! !

Object subclass: #CXSection
	instanceVariableNames: 'directives'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Parser'!

!CXSection class methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2009 23:41'!
directives: anArray
	^ self basicNew initializeWithDirectives: anArray! !

!CXSection class methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2009 23:41'!
new
	^ self directives: Array new! !

!CXSection class methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2009 23:41'!
with: aDirective
	^ self directives: (Array with: aDirective)! !

!CXSection methodsFor: 'accessing' stamp: 'cwp 12/16/2009 23:44'!
addDirective: aDirective
	directives := directives copyWith: aDirective! !

!CXSection methodsFor: 'accessing' stamp: 'cwp 12/16/2009 22:17'!
directives
	^ directives! !

!CXSection methodsFor: 'accessing' stamp: 'cwp 12/16/2009 23:42'!
initializeWithDirectives: anArray
	self initialize.
	directives := anArray! !
